/*

# Copyright (c) 2003 Todd T. Fries <todd@fries.net>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. The name of the author may not be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
# THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 compression
- sha1 based
  - pick a block size, "compress" based on
    sha1 signature
  - perhaps use some kind of info to help generate
    the data again, like number of bits, ??
  - verify that no earlier generated block of data
     generates the data, perhaps keep track of the
     match number
  - make it recognize a pattern the size of the hash,
    make hzip_PATTERN a flag(hash algorithm) for
    bits of repeating natures, implement later
  - header is 
	["hzip" + header size + filesize + pad]
      (allow for signing)
... the point is not to be fast but to
  guarantee shrinkage at the expense of cpu time
  for retrieval
    1024 bytes --> 16 bytes + overhead
*/


#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <openssl/evp.h>

#include "hzip.h"

int debug = 0;

int
main(int argc, char **argv)
{

#if TESTING
	printf("%d^%d = %d\n", atoi(argv[1]), atoi(argv[2]),
		atoi(argv[1]) ^ atoi(argv[2]));
	printf("TWO_POWER(%d) = %d\n", atoi(argv[1]),
		TWO_POWER(atoi(argv[1])));
	exit(0);
	printf("revpower(%d) = %d\n", atoi(argv[1]), revpower(atoi(argv[1])));
	exit(0);
#endif
	if (getenv("DEBUG")) {
		debug = atoi(getenv("DEBUG"));
		if (debug == 0)
			debug = 1;
	}

	/* -d file == unzip */
	/*    file == zip */
	if( ! strcmp(argv[1], "-d") ) {
		if (argc > 2)
			hunzip(argv[2]);
		else
			hunzip("/dev/stdin");
		return 0;
	}
	if (argc > 1)
		hzip(argv[1]);
	else
		hzip("/dev/stdin");
	return 0;
}
