/*

# Copyright (c) 2003 Todd T. Fries <todd@fries.net>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 compression
- sha1 based
  - pick a block size, "compress" based on
    sha1 signature
  - perhaps use some kind of info to help generate
    the data again, like number of bits, ??
  - verify that no earlier generated block of data
     generates the data, perhaps keep track of the
     match number
  - make it recognize a pattern the size of the hash,
    make hzip_PATTERN a flag(hash algorithm) for
    bits of repeating natures, implement later
  - header is 
	["hzip" + header size + filesize + pad]
      (allow for signing)
... the point is not to be fast but to
  guarantee shrinkage at the expense of cpu time
  for retrieval
    1024 bytes --> 16 bytes + overhead
*/


#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <openssl/evp.h>

#include "hzip.h"

int debug = 0;

int
main(int argc, char **argv)
{

#if TESTING
	printf("%d^%d = %d\n", atoi(argv[1]), atoi(argv[2]),
		atoi(argv[1]) ^ atoi(argv[2]));
	printf("TWO_POWER(%d) = %d\n", atoi(argv[1]),
		TWO_POWER(atoi(argv[1])));
	exit(0);
	printf("revpower(%d) = %d\n", atoi(argv[1]), revpower(atoi(argv[1])));
	exit(0);
#endif
	if (getenv("DEBUG")) {
		debug = atoi(getenv("DEBUG"));
		if (debug == 0)
			debug = 1;
	}

	/* -d file == unzip */
	/*    file == zip */
	if( ! strcmp(argv[1], "-d") ) {
		if (argc > 2)
			hunzip(argv[2]);
		else
			hunzip("/dev/stdin");
		return 0;
	}
	if (argc > 1)
		hzip(argv[1]);
	else
		hzip("/dev/stdin");
	return 0;
}
