/*

# Copyright (c) 2003 Todd T. Fries <todd@fries.net>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

*/

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <openssl/evp.h>

#include <hzip.h>

int debug = 0;
int
main(int argc, char **argv)
{
	if ( argc < 1 )
		exit(1);

	if(!strcmp("mask_set", argv[1])) {
		u_int8_t mask,result;
		u_int8_t i,j;
		u_int8_t init = 0xff;
		for (j=0; j <= init; j++) {
		for (i=0; i <= init; i++) {
			fprintf(stderr, "-\n");
			result = mask_set_add(init, i);
			if ( ! mask_set_check(result, i) )
				fprintf(stderr, "0x%02x did not check out ok\n", i);
			mask_set_check(result, j);
		}
		}
	}

	if(!strcmp("mask_unset", argv[1])) {
		u_int8_t mask,result;
		u_int8_t i,j;
		u_int8_t init = 0xff;
		for (j=0; j <= init; j++) {
		for (i=0; i <= init; i++) {
			fprintf(stderr, "-\n");
			result = mask_unset_add(init, i);
			if ( ! mask_unset_check(result, i) )
				fprintf(stderr, "0x%02x did not check out ok\n", i);
			mask_unset_check(result, j);
		}
		}
	}
	return 0;
}


